##
##  redis-mod-bloom.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
Name:         redis-mod-bloom
Summary:      Redis Extension Module: Bloom Filter
URL:          https://rebloom.io/
Vendor:       Redis Community
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Database
License:      RSAL
Version:      2.2.2
Release:      20200316

#   list of sources
Source0:      https://github.com/RedisLabsModules/rebloom/archive/v%{version}.tar.gz
Patch0:       redis-mod-bloom.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101
PreReq:       OpenPKG, openpkg >= 20160101
PreReq:       redis

%description
    This is a Redis extension module that implements two probabalistic
    data structures as Redis data types: Bloom Filters and Cuckoo
    Filters. These two structures are similar in their purpose but have
    different performance and functionality characteristics

%track
    prog redis-mod-bloom = {
        version   = %{version}
        url       = https://github.com/RedisLabsModules/rebloom/releases
        regex     = v(__VER__)\.tar\.gz
    }

%prep
    %setup -q -n RedisBloom-%{version}
    %patch -p0

%build
    #   build extension module
    %{l_make} %{l_mflags -O} \
        CC="%{l_cc}" \
        CFLAGS="%{l_cflags -O}"

%install
    #   create installation hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/libexec/redis

    #   install extension module
    %{l_shtool} install -c -m 755 \
        redisbloom.so $RPM_BUILD_ROOT%{l_prefix}/libexec/redis/bloom.so

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

%post
    if [ ".$1" = .1 ]; then
        #   add hook to Redis configuration
        redisconf="$RPM_INSTALL_PREFIX/etc/redis/redis.conf"
        if [ -f $redisconf ]; then
            echo "loadmodule $RPM_INSTALL_PREFIX/libexec/redis/bloom.so" |\
            $RPM_INSTALL_PREFIX/lib/openpkg/rpmtool config \
                -a -i "$RPM_INSTALL_PREFIX:redis-mod-bloom" -p "#" $redisconf
        fi
    fi

%postun
    if [ ".$1" = .0 ]; then
        #   remove hook from Redis configuration
        redisconf="$RPM_INSTALL_PREFIX/etc/redis/redis.conf"
        if [ -f $redisconf ]; then
            $RPM_INSTALL_PREFIX/lib/openpkg/rpmtool config \
                -r -i "$RPM_INSTALL_PREFIX:redis-mod-bloom" -p "#" $redisconf
        fi
    fi

